# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.paging import Paged


class OperationEntityPaged(Paged):
    """
    A paging container for iterating over a list of :class:`OperationEntity <azure.mgmt.storagesync.models.OperationEntity>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[OperationEntity]'}
    }

    def __init__(self, *args, **kwargs):

        super(OperationEntityPaged, self).__init__(*args, **kwargs)
class StorageSyncServicePaged(Paged):
    """
    A paging container for iterating over a list of :class:`StorageSyncService <azure.mgmt.storagesync.models.StorageSyncService>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[StorageSyncService]'}
    }

    def __init__(self, *args, **kwargs):

        super(StorageSyncServicePaged, self).__init__(*args, **kwargs)
class SyncGroupPaged(Paged):
    """
    A paging container for iterating over a list of :class:`SyncGroup <azure.mgmt.storagesync.models.SyncGroup>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[SyncGroup]'}
    }

    def __init__(self, *args, **kwargs):

        super(SyncGroupPaged, self).__init__(*args, **kwargs)
class CloudEndpointPaged(Paged):
    """
    A paging container for iterating over a list of :class:`CloudEndpoint <azure.mgmt.storagesync.models.CloudEndpoint>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[CloudEndpoint]'}
    }

    def __init__(self, *args, **kwargs):

        super(CloudEndpointPaged, self).__init__(*args, **kwargs)
class ServerEndpointPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ServerEndpoint <azure.mgmt.storagesync.models.ServerEndpoint>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ServerEndpoint]'}
    }

    def __init__(self, *args, **kwargs):

        super(ServerEndpointPaged, self).__init__(*args, **kwargs)
class RegisteredServerPaged(Paged):
    """
    A paging container for iterating over a list of :class:`RegisteredServer <azure.mgmt.storagesync.models.RegisteredServer>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[RegisteredServer]'}
    }

    def __init__(self, *args, **kwargs):

        super(RegisteredServerPaged, self).__init__(*args, **kwargs)
class WorkflowPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Workflow <azure.mgmt.storagesync.models.Workflow>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Workflow]'}
    }

    def __init__(self, *args, **kwargs):

        super(WorkflowPaged, self).__init__(*args, **kwargs)
